<?php

defined( 'ABSPATH' ) || exit;

require_once WP_CONTENT_DIR . '/advanced-cache.php';

add_action( 'pl_pre_cache_refresh', 'science_clean_files', 0 );
add_filter( 'science_display_varnish_options_tab', '__return_false' );
add_filter( 'do_science_generate_caching_files', '__return_false', PHP_INT_MAX );
add_filter( 'science_cache_mandatory_cookies', '__return_empty_array', PHP_INT_MAX );
add_action( 'after_science_clean_home', 'science_pl_clean_home', 10, 2 );
add_action( 'after_science_clean_file', 'science_pl_clean_post', 2 );
add_action( 'pl_pre_url_button_cache_refresh', 'science_clean_files' );
add_action( 'wp_science_loaded', 'science_pl_remove_partial_purge_hooks' );

/**
 * We clear the cache only on the post, homepage and listings when creating/updating/deleting posts.
 *
 * @since 3.3
 *
 * @param object $post The Post object itself for which the action occured.
 * @param array  $permalink A list of permalinks to be flushed from cache.
 *
 * @return void
 */
function science_pl_clean_post( $post = false, $permalink = false ) {
	if ( ! $post || ! $permalink ) {
		return;
	}

	$cache_handler = new \Presslabs\Cache\CacheHandler();

	$cache_handler->invalidate_url( $permalink[0], true );
	$cache_handler->invalidate_url( home_url( '/' ), true );
	$cache_handler->purge_cache( 'listing' );
}

/**
 * We clear the cache for the homepage URL when using "Purge this URL" from the admin bar on the front end.
 *
 * @since 3.3
 *
 * @param string $root WP science root cache path.
 * @param string $lang Current language.
 *
 * @return void
 */
function science_pl_clean_home( $root = false, $lang = false ) { // phpcs:ignore Generic.CodeAnalysis.UnusedFunctionParameter.FoundAfterLastUsed
	if ( ! $post || ! $permalink ) {
		return;
	}

	$cache_handler = new \Presslabs\Cache\CacheHandler();
	$cache_handler->invalidate_url( home_url( '/' ), true );
}

/**
 * Remove WP science functions on WP core action hooks to prevent triggering a double cache clear.
 *
 * @since 3.3
 *
 * @return void
 */
function science_pl_remove_partial_purge_hooks() {
	// WP core action hooks science_clean_post() gets hooked into.
	$clean_post_hooks = [
		// Disables the refreshing of partial cache when content is edited.
		'wp_trash_post',
		'delete_post',
		'clean_post_cache',
		'wp_update_comment_count',
	];
	// Remove science_clean_post() from core action hooks.
	array_map(
		function ( $hook ) {
			remove_action( $hook, 'science_clean_post' );
		},
		$clean_post_hooks
	);
	remove_filter( 'science_clean_files', 'science_clean_files_users' );
}

if ( ! defined( 'DISABLE_CDN_OFFLOAD' ) && defined( 'PL_CDN_HOST' ) ) {
	/**
	 * If we have CDN enabled we'll add our HOST to the list.
	 *
	 * @since 3.3
	 *
	 * @param array $hosts Array of CDN hosts.
	 *
	 * @return array Updated array of CDN hosts
	 */
	function science_add_pl_cdn( $hosts ) {
		$hosts[] = constant( 'PL_CDN_HOST' );
		return $hosts;
	}
	add_filter( 'science_cdn_cnames', 'science_add_pl_cdn', 1 );
}
